/* The MIT License (Open Source Approved)

Copyright (c) 2010 R. A. Nagy

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.

 */
package benchmarkone;

import com.soft9000.logger.StatusLog;
import javax.swing.JOptionPane;

/**
 *
 * @author R.A. Nagy
 */
public class guiMain extends javax.swing.JFrame {

    private boolean bLinpackWarning = false;

    /** Creates new form guiMain */
    public guiMain() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jpBenchmark = new javax.swing.JPanel();
        jpResults = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtaResults = new javax.swing.JTextArea();
        jpControls = new javax.swing.JPanel();
        jcbBenchType = new javax.swing.JComboBox();
        jbRunBenchmark = new javax.swing.JButton();
        jpAbout = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Computer Performance Tests");
        getContentPane().setLayout(new java.awt.CardLayout());

        jpBenchmark.setLayout(new java.awt.BorderLayout());

        jpResults.setBorder(javax.swing.BorderFactory.createTitledBorder(" Results "));
        jpResults.setLayout(new java.awt.CardLayout());

        jtaResults.setColumns(20);
        jtaResults.setRows(5);
        jScrollPane1.setViewportView(jtaResults);

        jpResults.add(jScrollPane1, "card2");

        jpBenchmark.add(jpResults, java.awt.BorderLayout.CENTER);

        jpControls.setBorder(javax.swing.BorderFactory.createTitledBorder(" Benchmarks "));
        jpControls.setPreferredSize(new java.awt.Dimension(395, 80));

        jcbBenchType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Whetstone", "Linpack" }));

        jbRunBenchmark.setText("Run");
        jbRunBenchmark.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbRunBenchmarkActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpControlsLayout = new javax.swing.GroupLayout(jpControls);
        jpControls.setLayout(jpControlsLayout);
        jpControlsLayout.setHorizontalGroup(
            jpControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpControlsLayout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addComponent(jcbBenchType, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(71, 71, 71)
                .addComponent(jbRunBenchmark)
                .addContainerGap(112, Short.MAX_VALUE))
        );
        jpControlsLayout.setVerticalGroup(
            jpControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpControlsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jcbBenchType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbRunBenchmark))
                .addContainerGap(16, Short.MAX_VALUE))
        );

        jpBenchmark.add(jpControls, java.awt.BorderLayout.PAGE_START);

        jTabbedPane1.addTab(" Benchmark ", jpBenchmark);

        jLabel1.setText("A Java porting of freely available computer performance algorythims");

        jLabel2.setText("Open-sourced at SourceForge.net");

        jLabel3.setFont(new java.awt.Font("Tahoma", 2, 11)); // NOI18N
        jLabel3.setText("-by R.A. Nagy");

        javax.swing.GroupLayout jpAboutLayout = new javax.swing.GroupLayout(jpAbout);
        jpAbout.setLayout(jpAboutLayout);
        jpAboutLayout.setHorizontalGroup(
            jpAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpAboutLayout.createSequentialGroup()
                .addContainerGap(67, Short.MAX_VALUE)
                .addGroup(jpAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpAboutLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(53, 53, 53))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpAboutLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(25, 25, 25))))
            .addGroup(jpAboutLayout.createSequentialGroup()
                .addGap(56, 56, 56)
                .addComponent(jLabel2)
                .addContainerGap(174, Short.MAX_VALUE))
        );
        jpAboutLayout.setVerticalGroup(
            jpAboutLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpAboutLayout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addComponent(jLabel1)
                .addGap(26, 26, 26)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 143, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addGap(25, 25, 25))
        );

        jTabbedPane1.addTab(" About ", jpAbout);

        getContentPane().add(jTabbedPane1, "card2");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jbRunBenchmarkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbRunBenchmarkActionPerformed
        StatusLog log = new StatusLog();
        int iPos = jcbBenchType.getSelectedIndex();
        this.jtaResults.setText("");
        switch (iPos) {
            case 0: {
                Operations.ExeStandardWhetstone(log);
            }
            break;
            default:
            case 1: {
                if (bLinpackWarning == false) {
                    JOptionPane.showMessageDialog(this.getRootPane(), "Warning: Linpack benchmark is not ready for prime-time yet.");
                    bLinpackWarning = true;
                }
                Operations.ExeStandardLinpack(log);
            }
            break;
        }
        String str = com.soft9000.file.TextReader.Read(log.getFile());
        this.jtaResults.setText(str);
        log.getFile().delete();

    }//GEN-LAST:event_jbRunBenchmarkActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                guiMain app = new guiMain();
                com.soft9000.gui.Misc.ScreenCenter(app);
                app.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbRunBenchmark;
    private javax.swing.JComboBox jcbBenchType;
    private javax.swing.JPanel jpAbout;
    private javax.swing.JPanel jpBenchmark;
    private javax.swing.JPanel jpControls;
    private javax.swing.JPanel jpResults;
    private javax.swing.JTextArea jtaResults;
    // End of variables declaration//GEN-END:variables
}
